> For the complete documentation index, see [llms.txt](https://docs.convai.com/api-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.convai.com/api-docs/plugins-and-integrations/unity-plugin/tutorials/npc2npc.md).

# NPC2NPC

This Unity tutorial demonstrates how to implement NPC-to-NPC conversations in 3D virtual environments using Convai's NPC2NPC feature. This functionality enables two NPCs to engage in dynamic, low-latency dialogues on predetermined topics, while allowing players or other game entities to interrupt and interact with them. Thus, this feature can create more engaging and interactive game worlds with use cases like storytelling, tutorial sequences or quest initiation

Check out this demo and tutorial on how to build this in Unity. We are also releasing the sample project source code along with the tutorial to get you started.

***

Download the free Sample project files:

{% embed url="<https://drive.google.com/file/d/1ddaxaRmdh_BTwO41KkipqwtD18Q11kYX/view?usp=drivesdk>" %}

***

Unity Asset Store plugin link:

{% embed url="<https://assetstore.unity.com/packages/tools/behavior-ai/npc-ai-engine-dialog-actions-voice-and-lipsync-convai-235621>" %}

***

Character Details

Name: Christina Smith\
ID: 64247ac6-74f8-11ef-be3e-42010a7be011

Name: Kevin Shaw\
ID: 7ffaee42-74f8-11ef-8980-42010a7be011

***

### Resources and References for your help

NPC2NPC Walkthrough:

Unity Factory Scene HDRP:

{% embed url="<https://assetstore.unity.com/packages/3d/environments/industrial/unity-factory-276400>" %}

Sign up at [Convai](https://convai.com/) to get started. For any questions or bug reports, please visit the [Convai Developer Forum](https://forum.convai.com/) where our community and support team will be happy to assist you.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.convai.com/api-docs/plugins-and-integrations/unity-plugin/tutorials/npc2npc.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
